/*
 * This file was generated automatically by xsubpp version 1.9507 from the 
 * contents of Apache.xs. Do not edit this file, edit Apache.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Apache.xs"
/* ====================================================================
 * Copyright (c) 1995-1998 The Apache Group.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * 4. The names "Apache Server" and "Apache Group" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission.
 *
 * 5. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * THIS SOFTWARE IS PROVIDED BY THE APACHE GROUP ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE APACHE GROUP OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Group and was originally based
 * on public domain software written at the National Center for
 * Supercomputing Applications, University of Illinois, Urbana-Champaign.
 * For more information on the Apache Group and the Apache HTTP server
 * project, please see <http://www.apache.org/>.
 *
 */

#define CORE_PRIVATE
#include "mod_perl.h"
#include "mod_perl_xs.h"

#if defined(PERL_STACKED_HANDLERS) && defined(PERL_GET_SET_HANDLERS)

#define PER_DIR_CONFIG 1
#define PER_SRV_CONFIG 2

typedef struct {
    int type;
    char *name;
    void *offset;
    void (*set_func) (void *, void *, SV *);
} perl_handler_table;

typedef struct {
    I32 fill;
    AV *av;
    AV **ptr;
} perl_save_av;

static void set_handler_dir (perl_handler_table *tab, request_rec *r, SV *sv);
static void set_handler_srv (perl_handler_table *tab, request_rec *r, SV *sv);

#define HandlerDirEntry(name,member) \
PER_DIR_CONFIG, name, (void*)XtOffsetOf(perl_dir_config,member), \
(void(*)(void *, void *, SV *)) set_handler_dir

#define HandlerSrvEntry(name,member) \
PER_SRV_CONFIG, name, (void*)XtOffsetOf(perl_server_config,member), \
(void(*)(void *, void *, SV *)) set_handler_srv

static perl_handler_table handler_table[] = {
    {HandlerSrvEntry("PerlPostReadRequestHandler", PerlPostReadRequestHandler)},
    {HandlerSrvEntry("PerlTransHandler", PerlTransHandler)},
    {HandlerDirEntry("PerlHeaderParserHandler", PerlHeaderParserHandler)},
    {HandlerDirEntry("PerlAccessHandler", PerlAccessHandler)},
    {HandlerDirEntry("PerlAuthenHandler", PerlAuthenHandler)},
    {HandlerDirEntry("PerlAuthzHandler", PerlAuthzHandler)},
    {HandlerDirEntry("PerlTypeHandler", PerlTypeHandler)},
    {HandlerDirEntry("PerlFixupHandler", PerlFixupHandler)},
    {HandlerDirEntry("PerlHandler", PerlHandler)},
    {HandlerDirEntry("PerlLogHandler", PerlLogHandler)},
    { FALSE, NULL }
};

static void perl_restore_av(void *data)
{
    perl_save_av *save_av = (perl_save_av *)data;

    if(save_av->fill != DONE) {
	AvFILLp(*save_av->ptr) = save_av->fill;
    }
    else if(save_av->av != Nullav) {
	*save_av->ptr = save_av->av;
    }
}

static void perl_handler_merge_avs(char *hook, AV **dest)
{
    int i = 0;
    HV *hv = perl_get_hv("Apache::PerlStackedHandlers", FALSE);
    SV **svp = hv_fetch(hv, hook, strlen(hook), FALSE);
    AV *base;
    
    if(!(svp && SvROK(*svp)))
	return;

    base = (AV*)SvRV(*svp);
    for(i=0; i<=AvFILL(base); i++) { 
	SV *sv = *av_fetch(base, i, FALSE);
	av_push(*dest, sv);
    }
}

static void set_handler_base(void *ptr, perl_handler_table *tab, pool *p, SV *sv) 
{
    AV **av = (AV **)((char *)ptr + (int)(long)tab->offset);

    perl_save_av *save_av = 
	(perl_save_av *)palloc(p, sizeof(perl_save_av));

    save_av->fill = DONE;
    save_av->av = Nullav;
    
    if((sv == &sv_undef) || (SvIOK(sv) && SvIV(sv) == DONE)) {
	if(AvTRUE(*av)) {
	    save_av->fill = AvFILL(*av);
	    AvFILLp(*av) = -1;
	}
    }
    else if(SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
	if(AvTRUE(*av))
	    save_av->av = av_copy_array(*av);
	*av = (AV*)SvRV(sv);
	++SvREFCNT(*av);
    }
    else {
	croak("Can't set_handler with that value");
    }
    save_av->ptr = av;
    register_cleanup(p, save_av, perl_restore_av, mod_perl_noop);
}

static void set_handler_dir(perl_handler_table *tab, request_rec *r, SV *sv)
{
    dPPDIR; 
    set_handler_base((void*)cld, tab, r->pool, sv);
}

static void set_handler_srv(perl_handler_table *tab, request_rec *r, SV *sv)
{
    dPSRV(r->server); 
    set_handler_base((void*)cls, tab, r->pool, sv);
}

static perl_handler_table *perl_handler_lookup(char *name)
{
    int i;
    for (i=0; handler_table[i].name; i++) {
	perl_handler_table *tab = &handler_table[i];
        if(strEQ(name, tab->name))
	    return tab;
    }
    return NULL;
}


static SV *get_handlers(request_rec *r, char *hook)
{
    AV *avcopy;
    AV **av;
    dPPDIR;
    dPSRV(r->server);
    void *ptr;
    perl_handler_table *tab = perl_handler_lookup(hook);

    if(!tab) return Nullsv;

    if(tab->type == PER_DIR_CONFIG)
	ptr = (void*)cld;
    else
	ptr = (void*)cls;

    av = (AV **)((char *)ptr + (int)(long)tab->offset);

    if(*av) 
	avcopy = av_copy_array(*av);
    else
	avcopy = newAV();

    perl_handler_merge_avs(hook, &avcopy);

    return newRV_noinc((SV*)avcopy);
}

static void set_handlers(request_rec *r, SV *hook, SV *sv)
{
    dTHR;
    perl_handler_table *tab = perl_handler_lookup(SvPV(hook,na));
    if(tab && tab->set_func) 
        (*tab->set_func)(tab, r, sv);

    (void)hv_delete_ent(perl_get_hv("Apache::PerlStackedHandlers", FALSE),
			hook, G_DISCARD, FALSE);
}
#endif

#if MODULE_MAGIC_NUMBER < 19970909
static void
child_terminate(request_rec *r)
{
#ifndef WIN32
    log_transaction(r);
#endif
    exit(0);
}
#endif

#if MODULE_MAGIC_NUMBER < MMN_132
void ap_custom_response(request_rec *r, int status, char *string)
{
    core_dir_config *conf = 
	get_module_config(r->per_dir_config, &core_module);
    int idx;

    if(conf->response_code_strings == NULL) {
        conf->response_code_strings = 
	    pcalloc(r->pool,
		    sizeof(*conf->response_code_strings) * 
		    RESPONSE_CODES);
    }

    idx = index_of_response(status);

    conf->response_code_strings[idx] = 
       ((is_url(string) || (*string == '/')) && (*string != '"')) ? 
       pstrdup(r->pool, string) : pstrcat(r->pool, "\"", string, NULL);
}
#endif

#ifndef custom_response
#define custom_response ap_custom_response
#endif

static void Apache_terminate_if_done(request_rec *r, int sts)
{
#ifndef WIN32
    if(Apache_exit_is_done(sts)) child_terminate(r);
#endif
}

#if MODULE_MAGIC_NUMBER < 19980317
int basic_http_header(request_rec *r);
#endif

#if MODULE_MAGIC_NUMBER < 19980201
unsigned get_server_port(const request_rec *r)
{
    unsigned port = r->server->port ? r->server->port : 80;

    return r->hostname ? ntohs(r->connection->local_addr.sin_port)
	: port;
}
#define get_server_name(r) \
    (r->hostname ? r->hostname : r->server->server_hostname) 
#endif

#if MODULE_MAGIC_AT_LEAST(19981108, 1)
#define mod_perl_define(sv,name) ap_exists_config_define(name)
#elif(MODULE_MAGIC_NUMBER >= MMN_131) && !defined(WIN32)
static int mod_perl_define(SV *sv, char *name)
{
    char **defines;
    int i;

    defines = (char **)ap_server_config_defines->elts;
    for (i = 0; i < ap_server_config_defines->nelts; i++) {
        if (strcmp(defines[i], name) == 0) {
            return 1;
        }
    }
    return 0;
}
#else
#define mod_perl_define(sv,name) 0
#endif

static int sv_str_header(void *arg, const char *k, const char *v)
{
    SV *sv = (SV*)arg;
    sv_catpvf(sv, "%s: %s\n", k, v);
    return 1;
}

#if MODULE_MAGIC_NUMBER >= 19980806
/*
 * ap_scan_script_header_err_core(r, buffer, getsfunc_SV, sv)
 */
#if 0
static int getsfunc_SV(char *buf, int bufsiz, void *param)
{
    SV *sv = (SV*)param;
    STRLEN len;
    char *tmp = SvPV(sv,len);
    int i;

    if(!SvTRUE(sv)) 
	return 0;

    for(i=0; i<=len; i++) {
	if(tmp[i] == LF) break;
    }

    Move(tmp, buf, i, char);
    buf[i] = '\0';

    if(len < i) {
	sv_setpv(sv, "");
    }
    else {
	tmp += i+1;
	sv_setpv(sv, tmp);
    }
    return 1;
}
#endif /*0*/
#endif /*MODULE_MAGIC_NUMBER*/

static void rwrite_neg_trace(request_rec *r)
{
#ifdef HAVE_APACHE_V_130
    ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server,
#else
    fprintf(stderr,
#endif
		 "mod_perl: rwrite returned -1 (fd=%d, B_EOUT=%d)",
		 r->connection->client->fd, 
		 r->connection->client->flags & B_EOUT);
}

#line 365 "Apache.c"
XS(XS_Apache_current_callback)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::current_callback(r)");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 367 "Apache.xs"
    RETVAL = newSVsv(perl_get_sv("Apache::__CurrentCallback", TRUE));

#line 379 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_sent_header)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::sent_header(r, val=0)");
    {
	Apache	r;
	int	val;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    val = 0;
	else {
	    val = (int)SvIV(ST(1));
	}

	RETVAL = mod_perl_sent_header(r, val);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_seqno)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::seqno(self, inc=0)");
    {
	SV *	self = ST(0);
	int	inc;
	int	RETVAL;

	if (items < 2)
	    inc = 0;
	else {
	    inc = (int)SvIV(ST(1));
	}

	RETVAL = mod_perl_seqno(self, inc);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_perl_hook)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::perl_hook(name)");
    {
	char *	name = (char *)SvPV(ST(0),PL_na);
	int	RETVAL;

	RETVAL = perl_hook(name);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

#if defined(PERL_GET_SET_HANDLERS)
#define XSubPPtmpAAAA 1

XS(XS_Apache_get_handlers)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::get_handlers(r, hook)");
    {
	Apache	r;
	char *	hook = (char *)SvPV(ST(1),PL_na);
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 393 "Apache.xs"
#ifdef get_handlers
    get_handlers(r,hook);
#else
    RETVAL = get_handlers(r,hook);
#endif

#line 471 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_set_handlers)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::set_handlers(r, hook, sv)");
    {
	Apache	r;
	SV *	hook = ST(1);
	SV *	sv = ST(2);

	r = sv2request_rec(ST(0), "Apache", cv);

	set_handlers(r, hook, sv);
    }
    XSRETURN_EMPTY;
}

#endif
XS(XS_Apache_push_handlers)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::push_handlers(self, hook, cv)");
    {
	SV *	self = ST(0);
	char *	hook = (char *)SvPV(ST(1),PL_na);
	SV *	cv = ST(2);
	int	RETVAL;
#line 417 "Apache.xs"
    RETVAL = mod_perl_push_handlers(self, hook, cv, Nullav);

#line 509 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_can_stack_handlers)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::can_stack_handlers(self)");
    {
	SV *	self = ST(0);
	int	RETVAL;

	RETVAL = mod_perl_can_stack_handlers(self);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_register_cleanup)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       croak("Usage: %s(r, sv)", GvNAME(CvGV(cv)));
    {
	Apache	r;
	SV *	sv = ST(1);
#line 435 "Apache.xs"
    ix = ix; /* avoid -Wall warning */
#line 543 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);

	mod_perl_register_cleanup(r, sv);
    }
    XSRETURN_EMPTY;
}

#define APACHE_REGISTRY_CURSTASH perl_get_sv("Apache::Registry::curstash", TRUE)
XS(XS_Apache_clear_rgy_endav)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::clear_rgy_endav(r, sv=APACHE_REGISTRY_CURSTASH)");
    {
	Apache	r;
	SV *	sv;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    sv = APACHE_REGISTRY_CURSTASH;
	else {
	    sv = ST(1);
	}

	mod_perl_clear_rgy_endav(r, sv);
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_stash_rgy_endav)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::stash_rgy_endav(r, sv=APACHE_REGISTRY_CURSTASH)");
    {
	Apache	r;
	SV *	sv;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    sv = APACHE_REGISTRY_CURSTASH;
	else {
	    sv = ST(1);
	}
#line 450 "Apache.xs"
    perl_stash_rgy_endav(r->uri, sv);
#line 593 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_define)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::define(sv, name)");
    {
	SV *	sv = ST(0);
	char *	name = (char *)SvPV(ST(1),PL_na);
	I32	RETVAL;

	RETVAL = mod_perl_define(sv, name);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_module)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::module(sv, name)");
    {
	SV *	sv = ST(0);
	SV *	name = ST(1);
	I32	RETVAL;
#line 463 "Apache.xs"
    if((*(SvEND(name) - 2) == '.') && (*(SvEND(name) - 1) == 'c'))
        RETVAL = find_linked_module(SvPVX(name)) ? 1 : 0;
    else
        RETVAL = (sv && perl_module_is_loaded(SvPVX(name)));

#line 630 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_set_opmask)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::set_opmask(r, sv)");
    {
	Apache	r;
	SV *	sv = ST(1);
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = mod_perl_set_opmask(r, sv);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_untaint)
{
    dXSARGS;
    {
#line 480 "Apache.xs"
    int i;

#line 663 "Apache.c"
#line 483 "Apache.xs"
    if(!tainting) XSRETURN_EMPTY;
    for(i=1; i<items; i++) 
        mod_perl_untaint(ST(i));
#line 668 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_taint)
{
    dXSARGS;
    {
#line 491 "Apache.xs"
    int i;

#line 680 "Apache.c"
#line 494 "Apache.xs"
    if(!tainting) XSRETURN_EMPTY;
    for(i=1; i<items; i++)
        sv_magic(ST(i), Nullsv, 't', Nullch, 0);
#line 685 "Apache.c"
    }
    XSRETURN_EMPTY;
}

#ifndef WIN32
#define XSubPPtmpAAAB 1

XS(XS_Apache_child_terminate)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::child_terminate(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);

	child_terminate(r);
    }
    XSRETURN_EMPTY;
}

#endif
XS(XS_Apache_exit)
{
    dXSARGS;
    {
#line 511 "Apache.xs"
    int sts = 0;
    request_rec *r = NULL;

#line 717 "Apache.c"
#line 515 "Apache.xs"
    /* $r->exit */
    r = sv2request_rec(ST(0), "Apache", cv);

    if(items > 1) {
        sts = (int)SvIV(ST(1));
    }
    else { /* Apache::exit() */
	if(SvTRUE(ST(0)) && SvIOK(ST(0)))
	    sts = (int)SvIV(ST(0));
    }

    MP_CHECK_REQ(r, "Apache::exit");

    if(!r->connection->aborted)
        rflush(r);
    Apache_terminate_if_done(r,sts);
    perl_call_halt(sts);
#line 736 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_CLOSE)
{
    dXSARGS;
    {
#line 540 "Apache.xs"
    items = items;
    /*NOOP*/
#line 748 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_as_string)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::as_string(r)");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 548 "Apache.xs"
    RETVAL = newSVpv(r->the_request,0);
    sv_catpvn(RETVAL, "\n", 1);

    table_do(sv_str_header, (void*)RETVAL, r->headers_in, NULL);
    sv_catpvf(RETVAL, "\n%s %s\n", r->protocol, r->status_line);

    table_do(sv_str_header, (void*)RETVAL, r->headers_out, NULL);
    table_do(sv_str_header, (void*)RETVAL, r->err_headers_out, NULL);
    sv_catpvn(RETVAL, "\n", 1);

#line 774 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_chdir_file)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::chdir_file(r, file=r->filename)");
    {
	Apache	r;
	const char *	file;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    file = r->filename;
	else {
	    file = (const char *)SvPV(ST(1),PL_na);
	}
#line 569 "Apache.xs"
    chdir_file(file);
#line 799 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_gensym)
{
    dXSARGS;
    if (items < 0 || items > 1)
	croak("Usage: Apache::gensym(pack=\"Apache::Symbol\")");
    {
	char *	pack;
	SV *	RETVAL;

	if (items < 1)
	    pack = "Apache::Symbol";
	else {
	    pack = (char *)SvPV(ST(0),PL_na);
	}

	RETVAL = mod_perl_gensym(pack);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_slurp_filename)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::slurp_filename(r)");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = mod_perl_slurp_filename(r);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_unescape_url)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::unescape_url(string)");
    {
	char *	string = (char *)SvPV(ST(0),PL_na);
	char *	RETVAL;
#line 584 "Apache.xs"
    unescape_url(string);
    RETVAL = string;

#line 856 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_unescape_url_info)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::unescape_url_info(url)");
    {
	char *	url = (char *)SvPV(ST(0),PL_na);
	char *	RETVAL;
#line 599 "Apache.xs"
    register char * trans = url ;
    char digit ;

    RETVAL = url;

    while (*url != '\0') {
        if (*url == '+')
            *trans = ' ';
	else if (*url != '%')
	    *trans = *url;
        else if (!isxdigit(url[1]) || !isxdigit(url[2]))
            *trans = '%';
        else {
            url++ ;
            digit = ((*url >= 'A') ? ((*url & 0xdf) - 'A')+10 : (*url - '0'));
            url++ ;
            *trans = (digit << 4) +
		(*url >= 'A' ? ((*url & 0xdf) - 'A')+10 : (*url - '0'));
        }
        url++, trans++ ;
    }
    *trans = '\0';

#line 895 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_hard_timeout)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::hard_timeout(r, string)");
    {
	Apache	r;
	char *	string = (char *)SvPV(ST(1),PL_na);

	r = sv2request_rec(ST(0), "Apache", cv);
#line 633 "Apache.xs"
#ifndef USE_THREADS
    hard_timeout(string, r);
#endif
#line 916 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_soft_timeout)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::soft_timeout(r, string)");
    {
	Apache	r;
	char *	string = (char *)SvPV(ST(1),PL_na);

	r = sv2request_rec(ST(0), "Apache", cv);
#line 643 "Apache.xs"
    soft_timeout(string, r);
#line 933 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_kill_timeout)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::kill_timeout(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 650 "Apache.xs"
#ifndef USE_THREADS
    kill_timeout(r);
#endif
#line 951 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_reset_timeout)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::reset_timeout(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);

	reset_timeout(r);
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_translate_name)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::translate_name(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 665 "Apache.xs"
#ifdef WIN32
    croak("Apache->translate_name not supported under Win32");
    RETVAL = DECLINED;
#else
    RETVAL = translate_name(r);
#endif

#line 989 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_custom_response)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::custom_response(r, status, string)");
    {
	Apache	r;
	int	status = (int)SvIV(ST(1));
	char *	string = (char *)SvPV(ST(2),PL_na);

	r = sv2request_rec(ST(0), "Apache", cv);

	custom_response(r, status, string);
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_satisfies)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::satisfies(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = satisfies(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_some_auth_required)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::some_auth_required(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = some_auth_required(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_requires)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::requires(r)");
    {
	Apache	r;
#line 696 "Apache.xs"
    AV *av;
    HV *hv;
    register int x;
    int m;
    char *t;
    MP_CONST_ARRAY_HEADER *reqs_arr;
    require_line *reqs;

#line 1065 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 705 "Apache.xs"
    m = r->method_number;
    reqs_arr = requires (r);

    if (!reqs_arr)
	ST(0) = &sv_undef;
    else {
	reqs = (require_line *)reqs_arr->elts;
	iniAV(av);
        for(x=0; x < reqs_arr->nelts; x++) {
	    /* XXX should we do this or let PerlAuthzHandler? */
	    if (! (reqs[x].method_mask & (1 << m))) continue;
	    t = reqs[x].requirement;
	    iniHV(hv);
	    hv_store(hv, "method_mask", 11, 
		     newSViv((IV)reqs[x].method_mask), 0);
	    hv_store(hv, "requirement", 11, 
		     newSVpv(reqs[x].requirement,0), 0);
	    av_push(av, newRV((SV*)hv));
	}
	ST(0) = newRV_noinc((SV*)av); 
    }
#line 1090 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_allow_options)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::allow_options(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = allow_options(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_get_server_port)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::get_server_port(r)");
    {
	Apache	r;
	unsigned	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = get_server_port(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_get_server_name)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::get_server_name(r)");
    {
	Apache	r;
	const char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = get_server_name(r);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_get_remote_host)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::get_remote_host(r, type=REMOTE_NAME)");
    {
	Apache	r;
	int	type;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    type = REMOTE_NAME;
	else {
	    type = (int)SvIV(ST(1));
	}
#line 745 "Apache.xs"
    RETVAL = (char *)get_remote_host(r->connection, 
				     r->per_dir_config, type);

#line 1170 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_get_remote_logname)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::get_remote_logname(r)");
    {
	Apache	r;
	const char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = get_remote_logname(r);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_auth_name)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::auth_name(r, val=NULL)");
    {
	Apache	r;
	char *	val;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    val = NULL;
	else {
	    val = (char *)SvPV(ST(1),PL_na);
	}

	RETVAL = mod_perl_auth_name(r, val);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_auth_type)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::auth_type(r)");
    {
	Apache	r;
	const char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = auth_type(r);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_document_root)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::document_root(r)");
    {
	Apache	r;
	const char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = document_root(r);
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_server_root_relative)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::server_root_relative(rsv, name=\"\")");
    {
	SV *	rsv = ST(0);
	char *	name;
#line 774 "Apache.xs"
    pool *p;
    request_rec *r;

#line 1268 "Apache.c"
	char *	RETVAL;

	if (items < 2)
	    name = "";
	else {
	    name = (char *)SvPV(ST(1),PL_na);
	}
#line 778 "Apache.xs"
    if (SvROK(rsv) && (r = sv2request_rec(rsv, "Apache", cv))) {
	p = r->pool;
    }
    else {
	if(!(p = perl_get_startup_pool()))
	   croak("Apache::server_root_relative: no startup pool available");
    }

    RETVAL = (char *)server_root_relative(p, name);

#line 1287 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_note_basic_auth_failure)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::note_basic_auth_failure(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);

	note_basic_auth_failure(r);
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_get_basic_auth_pw)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::get_basic_auth_pw(r)");
    SP -= items;
    {
	Apache	r;
#line 802 "Apache.xs"
    MP_CONST_CHAR *sent_pw = NULL;
    int ret;

#line 1321 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 806 "Apache.xs"
    ret = get_basic_auth_pw(r, &sent_pw);
    XPUSHs(sv_2mortal((SV*)newSViv(ret)));
    if(ret == OK)
	XPUSHs(sv_2mortal((SV*)newSVpv((char *)sent_pw, 0)));
    else
	XPUSHs(&sv_undef);
#line 1331 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_basic_http_header)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::basic_http_header(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 818 "Apache.xs"
#ifdef WIN32
    croak("Apache->basic_http_header() not supported under Win32!");
#else
    basic_http_header(r);
#endif
#line 1352 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_send_http_header)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::send_http_header(r, type=NULL)");
    {
	Apache	r;
	char *	type;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    type = NULL;
	else {
	    type = (char *)SvPV(ST(1),PL_na);
	}
#line 830 "Apache.xs"
    if(type)
        r->content_type = pstrdup(r->pool, type);
    send_http_header(r);
    mod_perl_sent_header(r, 1);
    r->status = 200; /* XXX, why??? */
#line 1379 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_send_fd)
{
    dXSARGS;
    if (items < 2 || items > 3)
	croak("Usage: Apache::send_fd(r, f, length=-1)");
    {
	Apache	r;
	FILE *	f = IoIFP(sv_2io(ST(1)));
	long	length;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 3)
	    length = -1;
	else {
	    length = (long)SvIV(ST(2));
	}
#line 843 "Apache.xs"
    RETVAL = send_fd_length(f, r, length);

#line 1405 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_rflush)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::rflush(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = rflush(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_read_client_block)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::read_client_block(r, buffer, bufsiz)");
    SP -= items;
    {
	Apache	r;
	char *	buffer = (char *)SvPV(ST(1),PL_na);
	int	bufsiz = (int)SvIV(ST(2));
#line 859 "Apache.xs"
    long nrd = 0;

#line 1443 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 862 "Apache.xs"
    buffer = (char*)safemalloc(bufsiz);
    PERL_READ_FROM_CLIENT;
    if ( nrd > 0 ) {
	XPUSHs(sv_2mortal(newSViv((long)nrd)));
	sv_setpvn((SV*)ST(1), buffer, nrd);
#ifdef PERL_STASH_POST_DATA
        table_set(r->subprocess_env, "POST_DATA", buffer);
#endif
        safefree(buffer);
	SvTAINTED_on((SV*)ST(1));
    } 
    else {
	ST(1) = &sv_undef;
    }
#line 1461 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_setup_client_block)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::setup_client_block(r, policy=REQUEST_CHUNKED_ERROR)");
    {
	Apache	r;
	int	policy;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    policy = REQUEST_CHUNKED_ERROR;
	else {
	    policy = (int)SvIV(ST(1));
	}

	RETVAL = setup_client_block(r, policy);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_should_client_block)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::should_client_block(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = should_client_block(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_get_client_block)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::get_client_block(r, buffer, bufsiz)");
    SP -= items;
    {
	Apache	r;
	char *	buffer = (char *)SvPV(ST(1),PL_na);
	int	bufsiz = (int)SvIV(ST(2));
#line 893 "Apache.xs"
    long nrd = 0;

#line 1523 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 896 "Apache.xs"
    buffer = (char*)palloc(r->pool, bufsiz);
    nrd = get_client_block(r, buffer, bufsiz);
    if ( nrd > 0 ) {
	XPUSHs(sv_2mortal(newSViv((long)nrd)));
	sv_setpvn((SV*)ST(1), buffer, nrd);
	SvTAINTED_on((SV*)ST(1));
    } 
    else {
	ST(1) = &sv_undef;
    }
#line 1537 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_print)
{
    dXSARGS;
    dXSI32;
    if (items < 1)
       croak("Usage: %s(r, ...)", GvNAME(CvGV(cv)));
    {
	Apache	r;
#line 915 "Apache.xs"
    ix = ix; /* avoid -Wall warning */

#line 1554 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 918 "Apache.xs"
    if(!mod_perl_sent_header(r, 0)) {
	SV *sv = sv_newmortal();
	SV *rp = ST(0);
	SV *sendh = perl_get_sv("Apache::__SendHeader", TRUE);

	if(items > 2)
	    do_join(sv, &sv_no, MARK+1, SP); /* $sv = join '', @_[1..$#_] */
        else
	    sv_setsv(sv, ST(1));

	PUSHMARK(sp);
	XPUSHs(rp);
	XPUSHs(sv);
	PUTBACK;
	sv_setiv(sendh, 1);
	perl_call_pv("Apache::send_cgi_header", G_SCALAR);
	sv_setiv(sendh, 0);
    }
    else {
	CV *cv = GvCV(gv_fetchpv("Apache::write_client", FALSE, SVt_PVCV));
	hard_timeout("mod_perl: Apache->print", r);
	PUSHMARK(mark);
	(void)(*CvXSUB(cv))(cv); /* &Apache::write_client; */

	if(IoFLAGS(GvIOp(defoutgv)) & IOf_FLUSH) /* if $| != 0; */
#if MODULE_MAGIC_NUMBER >= 19970103
	    rflush(r);
#else
	    bflush(r->connection->client);
#endif
	kill_timeout(r);
    }
#line 1590 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_write_client)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::write_client(r, ...)");
    {
	Apache	r;
#line 956 "Apache.xs"
    int i;
    char * buffer;
    STRLEN len;

#line 1607 "Apache.c"
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 961 "Apache.xs"
    RETVAL = 0;

    for(i = 1; i <= items - 1; i++) {
	int sent = 0;
        SV *sv = SvROK(ST(i)) && (SvTYPE(SvRV(ST(i))) == SVt_PV) ?
                 (SV*)SvRV(ST(i)) : ST(i);
	buffer = SvPV(sv, len);
#ifdef APACHE_SSL
        while(len > 0) {
            sent = 0;
	    if(len < HUGE_STRING_LEN) {
	        sent = rwrite(buffer, len, r);
	    }
	    else {
	        sent = rwrite(buffer, HUGE_STRING_LEN, r);
	        buffer += HUGE_STRING_LEN;
	    }
	    if(sent < 0) {
		rwrite_neg_trace(r);
		break;
	    }
	    len -= sent;
	    RETVAL += sent;
        }
#else
        if((sent = rwrite(buffer, len, r)) < 0) {
	    rwrite_neg_trace(r);
	    break;
        }
        RETVAL += sent;
#endif
    }
#line 1644 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_internal_redirect_handler)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       croak("Usage: %s(r, location)", GvNAME(CvGV(cv)));
    {
	Apache	r;
	char *	location = (char *)SvPV(ST(1),PL_na);

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1004 "Apache.xs"
    switch((ix = XSANY.any_i32)) {
	case 0:
	internal_redirect_handler(location, r);
	break;
	case 1:
	internal_redirect(location, r);
	break;
    }
#line 1669 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_log_reason)
{
    dXSARGS;
    if (items < 2 || items > 3)
	croak("Usage: Apache::log_reason(r, reason, filename=NULL)");
    {
	Apache	r;
	char *	reason = (char *)SvPV(ST(1),PL_na);
	char *	filename;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 3)
	    filename = NULL;
	else {
	    filename = (char *)SvPV(ST(2),PL_na);
	}
#line 1022 "Apache.xs"
    if(filename == NULL)
        filename = r->uri; 
    mod_perl_log_reason(reason, filename, r);
#line 1695 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache_log_error)
{
    dXSARGS;
    dXSI32;
    {
#line 1035 "Apache.xs"
    server_rec *s = NULL;
    request_rec *r = NULL;
    int i=0;
    char *errstr = NULL;
    SV *sv = Nullsv;

#line 1712 "Apache.c"
#line 1042 "Apache.xs"
    if((items > 1) && (r = sv2request_rec(ST(0), "Apache", cv))) {
	s = r->server;
	i=1;
    }
    else if((items > 1) && sv_derived_from(ST(0), "Apache::Server")) {
	IV tmp = SvIV((SV*)SvRV(ST(0)));
	s = (Apache__Server )tmp;
	i=1;	

	/* if below is true, delay log_error */
	if(PERL_RUNNING() < PERL_DONE_STARTUP) {
	    MP_TRACE_g(fprintf(stderr, "error_log not open yet\n"));
	    XSRETURN_UNDEF;
	}
    }
    else { 
	if(r) 
	    s = r->server;
	else
	    s = perl_get_startup_server();
    }

    if(!s) croak("Apache::warn: no server_rec!");

    if(items > 1+i) {
	sv = newSV(0);
        do_join(sv, &sv_no, MARK+i, SP); /* $sv = join '', @_[1..$#_] */
        errstr = SvPV(sv,na);
    }
    else
        errstr = SvPV(ST(i),na);

    switch((ix = XSANY.any_i32)) {
	case 0:
	case 2:
	mod_perl_error(s, errstr);
	break;

	case 1:
	case 3:
	mod_perl_warn(s, errstr);
	break;

        default:
	mod_perl_error(s, errstr);
	break;
    }

    if(sv) SvREFCNT_dec(sv);
#line 1763 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_subprocess_env)
{
    dXSARGS;
    dXSI32;
    if (items < 1)
       croak("Usage: %s(r, key=NULL, ...)", GvNAME(CvGV(cv)));
    {
	Apache	r;
	char *	key;
#line 1104 "Apache.xs"
    I32 gimme = GIMME_V;

#line 1780 "Apache.c"
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV(ST(1),PL_na);
	}
#line 1107 "Apache.xs"
    if(((ix = XSANY.any_i32) == 1) && (gimme == G_ARRAY)) {
	/* backwards compat */
	int i;
	array_header *arr  = perl_cgi_env_init(r);
	table_entry *elts = (table_entry *)arr->elts;
	SP -= items;
	for (i = 0; i < arr->nelts; ++i) {
	    if (!elts[i].key) continue;
	    PUSHelt(elts[i].key, elts[i].val, 0);
	}
	PUTBACK;
	return;
    }
    if((items == 1) && (gimme == G_VOID)) {
        (void)perl_cgi_env_init(r);
        XSRETURN_UNDEF;
    }
    TABLE_GET_SET(r->subprocess_env, FALSE);

#line 1810 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_request)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::request(self, r=NULL)");
    SP -= items;
    {
	SV *	self = ST(0);
	Apache	r;

	if (items < 2)
	    r = NULL;
	else {
	    r = sv2request_rec(ST(1), "Apache", cv);
	}
#line 1139 "Apache.xs"
    self = self;
    if(items > 1) perl_request_rec(r);
    XPUSHs(perl_bless_request_rec(perl_request_rec(NULL)));
#line 1836 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_connection)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::connection(r)");
    {
	Apache	r;
	Apache__Connection	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1152 "Apache.xs"
    RETVAL = r->connection;

#line 1855 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Connection", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_server)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::server(rsv)");
    {
	SV *	rsv = ST(0);
#line 1162 "Apache.xs"
    server_rec *s;
    request_rec *r;

#line 1873 "Apache.c"
	Apache__Server	RETVAL;
#line 1166 "Apache.xs"
    if (SvROK(rsv) && (r = sv2request_rec(rsv, "Apache", cv))) {
	s = r->server;
    }
    else {
	if(!(s = perl_get_startup_server()))
	   croak("Apache->server: no startup server_rec available");
    }

    RETVAL = s;

#line 1886 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Server", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_main)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::main(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1212 "Apache.xs"
    if(r->main != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->main);
    else
        ST(0) = &sv_undef;
#line 1907 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_prev)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::prev(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1222 "Apache.xs"
    if(r->prev != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->prev);
    else
        ST(0) = &sv_undef;
#line 1926 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_next)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::next(r)");
    {
	Apache	r;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1232 "Apache.xs"
    if(r->next != NULL)
 	ST(0) = perl_bless_request_rec((request_rec *)r->next);
    else
        ST(0) = &sv_undef;
#line 1945 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_last)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::last(r)");
    {
	Apache	r;
	Apache	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1242 "Apache.xs"
    for(RETVAL=r; RETVAL->next; RETVAL=RETVAL->next)
        continue;

#line 1964 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache", (void*)RETVAL);

    }
    XSRETURN(1);
}

XS(XS_Apache_is_initial_req)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::is_initial_req(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	RETVAL = is_initial_req(r);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_is_main)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::is_main(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1257 "Apache.xs"
    if(r->main != NULL) RETVAL = 0;
    else RETVAL = 1;

#line 2004 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_the_request)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::the_request(r)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1268 "Apache.xs"
    RETVAL = r->the_request;

#line 2024 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_proxyreq)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::proxyreq(r, ...)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1278 "Apache.xs"
    get_set_IV(r->proxyreq);

#line 2044 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_header_only)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::header_only(r)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1288 "Apache.xs"
    RETVAL = r->header_only;

#line 2064 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_protocol)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::protocol(r)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1298 "Apache.xs"
    RETVAL = r->protocol;

#line 2084 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_hostname)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::hostname(r)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1308 "Apache.xs"
    RETVAL = (char *)r->hostname;

#line 2104 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_status)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::status(r, ...)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1318 "Apache.xs"
    get_set_IV(r->status);

#line 2124 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_request_time)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::request_time(r)");
    {
	Apache	r;
	time_t	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1328 "Apache.xs"
    RETVAL = r->request_time;

#line 2144 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setnv(ST(0), (double)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_status_line)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::status_line(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1338 "Apache.xs"
    get_set_PVp(r->status_line,r->pool);

#line 2164 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_method)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::method(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1358 "Apache.xs"
    get_set_PVp(r->method,r->pool);

#line 2184 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_method_number)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::method_number(r, ...)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1368 "Apache.xs"
    get_set_IV(r->method_number);

#line 2204 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_bytes_sent)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::bytes_sent(r, ...)");
    {
	Apache	r;
#line 1378 "Apache.xs"
    request_rec *last;

#line 2221 "Apache.c"
	long	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1382 "Apache.xs"
    for(last=r; last->next; last=last->next)
        continue;

    RETVAL = last->bytes_sent;

    if(items > 1)
        r->bytes_sent = (long)SvIV(ST(1));

#line 2234 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_read_length)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::read_length(r, len=-1)");
    {
	Apache	r;
	long	len;
	long	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    len = -1;
	else {
	    len = (long)SvIV(ST(1));
	}
#line 1399 "Apache.xs"
    RETVAL = r->read_length;
    if(len > -1)
        r->read_length = len;
#line 2262 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_header_in)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Apache::header_in(r, key, ...)");
    {
	Apache	r;
	char *	key = (char *)SvPV(ST(1),PL_na);
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1435 "Apache.xs"
    TABLE_GET_SET(r->headers_in, TRUE);

#line 2281 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_headers_in)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::headers_in(r)");
    SP -= items;
    {
	Apache	r;
#line 1446 "Apache.xs"
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;

#line 2301 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1451 "Apache.xs"
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->headers_in); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->headers_in);
    hdrs = (table_entry *)hdrs_arr->elts;

    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
#line 2316 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_header_out)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Apache::header_out(r, key, ...)");
    {
	Apache	r;
	char *	key = (char *)SvPV(ST(1),PL_na);
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1469 "Apache.xs"
    TABLE_GET_SET(r->headers_out, TRUE);

#line 2336 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_cgi_header_out)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Apache::cgi_header_out(r, key, ...)");
    {
	Apache	r;
	char *	key = (char *)SvPV(ST(1),PL_na);
#line 1480 "Apache.xs"
    char *val;

#line 2354 "Apache.c"
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1483 "Apache.xs"
    if((val = (char *)table_get(r->headers_out, key))) 
	RETVAL = newSVpv(val, 0);
    else
        RETVAL = newSV(0);

    SvTAINTED_on(RETVAL);

    if(items > 2) {
	int status = 302;
	val = SvPV(ST(2),na);
        if(!strncasecmp(key, "Content-type", 12)) {
	    r->content_type = pstrdup (r->pool, val);
	}
        else if(!strncasecmp(key, "Status", 6)) {
            sscanf(val, "%d", &r->status);
            r->status_line = pstrdup(r->pool, val);
        }
        else if(!strncasecmp(key, "Location", 8)) {
	    if (val && val[0] == '/' && r->status == 200) {
		/* not sure if this is quite right yet */
		/* set $Apache::DoInternalRedirect++ to test */
		if(DO_INTERNAL_REDIRECT) {
		    r->method = pstrdup(r->pool, "GET");
		    r->method_number = M_GET;

		    table_unset(r->headers_in, "Content-Length");

		    status = 200;
		    perl_soak_script_output(r);
		    internal_redirect_handler(val, r);
		}
	    }
	    table_set (r->headers_out, key, val);
	    r->status = status;
        }   
        else if(!strncasecmp(key, "Content-Length", 14)) {
	    table_set (r->headers_out, key, val);
        }   
        else if(!strncasecmp(key, "Transfer-Encoding", 17)) {
	    table_set (r->headers_out, key, val);
        }   


	else if(!strncasecmp(key, "Set-Cookie", 10)) {
	    table_add(r->err_headers_out, key, val);
	}
        else {
	    table_merge (r->err_headers_out, key, val);
        }
    }
#line 2409 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_headers_out)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::headers_out(r)");
    SP -= items;
    {
	Apache	r;
#line 1543 "Apache.xs"
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;

#line 2427 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1548 "Apache.xs"
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->headers_out); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->headers_out);
    hdrs = (table_entry *)hdrs_arr->elts;
    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
#line 2441 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_err_header_out)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Apache::err_header_out(r, key, ...)");
    {
	Apache	r;
	char *	key = (char *)SvPV(ST(1),PL_na);
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1565 "Apache.xs"
    TABLE_GET_SET(r->err_headers_out, TRUE);

#line 2461 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_err_headers_out)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::err_headers_out(r, ...)");
    SP -= items;
    {
	Apache	r;
#line 1575 "Apache.xs"
    int i;
    array_header *hdrs_arr;
    table_entry  *hdrs;

#line 2481 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1580 "Apache.xs"
    if(GIMME == G_SCALAR) {
	ST(0) = mod_perl_tie_table(r->err_headers_out); 
	XSRETURN(1); 	
    }
    hdrs_arr = table_elts (r->err_headers_out);
    hdrs = (table_entry *)hdrs_arr->elts;

    for (i = 0; i < hdrs_arr->nelts; ++i) {
	if (!hdrs[i].key) continue;
	PUSHelt(hdrs[i].key, hdrs[i].val, 0);
    }
#line 2496 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_notes)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::notes(r, key=NULL, ...)");
    {
	Apache	r;
	char *	key;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV(ST(1),PL_na);
	}
#line 1598 "Apache.xs"
    TABLE_GET_SET(r->notes, FALSE);

#line 2522 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_pnotes)
{
    dXSARGS;
    if (items < 1 || items > 3)
	croak("Usage: Apache::pnotes(r, k=Nullsv, val=Nullsv)");
    {
	Apache	r;
	SV *	k;
	SV *	val;
#line 1610 "Apache.xs"
    perl_request_config *cfg;
    char *key = NULL;
    STRLEN len;

#line 2543 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    k = Nullsv;
	else {
	    k = ST(1);
	}

	if (items < 3)
	    val = Nullsv;
	else {
	    val = ST(2);
	}
#line 1615 "Apache.xs"
    if(k) {
	key = SvPV(k,len);
    }
    cfg = get_module_config(r->request_config, &perl_module);
    if(!cfg->pnotes) cfg->pnotes = newHV();
    if(key) {
	if(hv_exists(cfg->pnotes, key, len)) {
	    ST(0) = SvREFCNT_inc(*hv_fetch(cfg->pnotes, key, len, FALSE));
	    sv_2mortal(ST(0));
	}
	else {
	    ST(0) = &sv_undef;
	}
	if(val) {
	    hv_store(cfg->pnotes, key, len, SvREFCNT_inc(val), FALSE);
	}
    }
    else {
	ST(0) = newRV_inc((SV*)cfg->pnotes);
	sv_2mortal(ST(0));
    }
#line 2580 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_content_type)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::content_type(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1642 "Apache.xs"
    get_set_PVp(r->content_type,r->pool);

#line 2598 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_handler)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::handler(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1652 "Apache.xs"
    get_set_PVp(r->handler,r->pool);

#line 2618 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_content_encoding)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::content_encoding(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1662 "Apache.xs"
    get_set_PVp(r->content_encoding,r->pool);

#line 2638 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_content_language)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::content_language(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1672 "Apache.xs"
    get_set_PVp(r->content_language,r->pool);

#line 2658 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_content_languages)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::content_languages(r, avrv=Nullsv)");
    {
	Apache	r;
	SV *	avrv;
#line 1683 "Apache.xs"
    I32 gimme = GIMME_V;

#line 2676 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    avrv = Nullsv;
	else {
	    avrv = ST(1);
	}
#line 1686 "Apache.xs"
    if(avrv && SvROK(avrv))
        r->content_languages = avrv2array_header(avrv, r->pool);

    if(gimme != G_VOID)
        ST(0) = array_header2avrv(r->content_languages);
#line 2691 "Apache.c"
    }
    XSRETURN(1);
}

XS(XS_Apache_no_cache)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::no_cache(r, ...)");
    {
	Apache	r;
	int	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1697 "Apache.xs"
    get_set_IV(r->no_cache);

#line 2709 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_finfo)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::finfo(r)");
    {
	Apache	r;
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1718 "Apache.xs"
    statcache = r->finfo;
    if (r->finfo.st_mode) {
	laststatval = 0;
    }
    else {
	laststatval = -1;
    }
    if(GIMME_V == G_VOID) XSRETURN_UNDEF;
    RETVAL = newRV_noinc((SV*)gv_fetchpv("_", TRUE, SVt_PVIO));

#line 2737 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_uri)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::uri(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1736 "Apache.xs"
    get_set_PVp(r->uri,r->pool);

#line 2757 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_filename)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::filename(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1746 "Apache.xs"
    get_set_PVp(r->filename,r->pool);
#ifndef WIN32
    if(items > 1)
	stat(r->filename, &r->finfo);
#endif

#line 2781 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_path_info)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::path_info(r, ...)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1760 "Apache.xs"
    get_set_PVp(r->path_info,r->pool);

#line 2801 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_query_string)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::query_string(r, ...)");
    SP -= items;
    {
	Apache	r;
#line 1770 "Apache.xs"
    SV *sv = sv_newmortal();

#line 2819 "Apache.c"

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1773 "Apache.xs"
    if(r->args)
	sv_setpv(sv, r->args);
    SvTAINTED_on(sv);
    XPUSHs(sv);

    if(items > 1)
        r->args = pstrdup(r->pool, (char *)SvPV(ST(1),na));
#line 2830 "Apache.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache_location)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::location(r)");
    {
	Apache	r;
	char *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1793 "Apache.xs"
    if(r->per_dir_config) {				   
	dPPDIR;
        RETVAL = cld->location;
    }
    else XSRETURN_UNDEF;

#line 2853 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_dir_config)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Apache::dir_config(r, key=NULL, ...)");
    {
	Apache	r;
	char *	key;
#line 1808 "Apache.xs"
    perl_dir_config *c;

#line 2871 "Apache.c"
	SV *	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV(ST(1),PL_na);
	}
#line 1811 "Apache.xs"
    if(r->per_dir_config) {				   
        c = get_module_config(r->per_dir_config, &perl_module);
        TABLE_GET_SET(c->vars, FALSE);
    }
    else XSRETURN_UNDEF;

#line 2888 "Apache.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache_lookup_uri)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::lookup_uri(r, uri)");
    {
	Apache	r;
	char *	uri = (char *)SvPV(ST(1),PL_na);
	Apache__SubRequest	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1837 "Apache.xs"
    RETVAL = sub_req_lookup_uri(uri,r);

#line 2909 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::SubRequest", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache_lookup_file)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::lookup_file(r, file)");
    {
	Apache	r;
	char *	file = (char *)SvPV(ST(1),PL_na);
	Apache__SubRequest	RETVAL;

	r = sv2request_rec(ST(0), "Apache", cv);
#line 1848 "Apache.xs"
    RETVAL = sub_req_lookup_file(file,r);

#line 2930 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::SubRequest", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache__SubRequest_DESTROY)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::SubRequest::DESTROY(r)");
    {
	Apache__SubRequest	r;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = (Apache__SubRequest) tmp;
	}
	else
	    croak("r is not a reference");
#line 1863 "Apache.xs"
    destroy_sub_req(r);
    MP_TRACE_g(fprintf(stderr, 
	    "Apache::SubRequest::DESTROY(0x%lx)\n", (unsigned long)r));
#line 2955 "Apache.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__SubRequest_run)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::SubRequest::run(r)");
    {
	Apache__SubRequest	r;
	int	RETVAL;

	if (sv_derived_from(ST(0), "Apache::SubRequest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = (Apache__SubRequest) tmp;
	}
	else
	    croak("r is not of type Apache::SubRequest");
#line 1872 "Apache.xs"
    RETVAL = run_sub_req(r);

#line 2978 "Apache.c"
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Apache)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Apache::current_callback", XS_Apache_current_callback, file);
        newXS("Apache::sent_header", XS_Apache_sent_header, file);
        newXS("Apache::seqno", XS_Apache_seqno, file);
        newXS("Apache::perl_hook", XS_Apache_perl_hook, file);
#if XSubPPtmpAAAA
        newXS("Apache::get_handlers", XS_Apache_get_handlers, file);
        newXS("Apache::set_handlers", XS_Apache_set_handlers, file);
#endif
        newXS("Apache::push_handlers", XS_Apache_push_handlers, file);
        newXS("Apache::can_stack_handlers", XS_Apache_can_stack_handlers, file);
        cv = newXS("Apache::register_cleanup", XS_Apache_register_cleanup, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::post_connection", XS_Apache_register_cleanup, file);
        XSANY.any_i32 = 1 ;
        newXS("Apache::clear_rgy_endav", XS_Apache_clear_rgy_endav, file);
        newXS("Apache::stash_rgy_endav", XS_Apache_stash_rgy_endav, file);
        newXS("Apache::define", XS_Apache_define, file);
        newXS("Apache::module", XS_Apache_module, file);
        newXS("Apache::set_opmask", XS_Apache_set_opmask, file);
        newXS("Apache::untaint", XS_Apache_untaint, file);
        newXS("Apache::taint", XS_Apache_taint, file);
#if XSubPPtmpAAAB
        newXS("Apache::child_terminate", XS_Apache_child_terminate, file);
#endif
        newXS("Apache::exit", XS_Apache_exit, file);
        newXS("Apache::CLOSE", XS_Apache_CLOSE, file);
        newXS("Apache::as_string", XS_Apache_as_string, file);
        newXS("Apache::chdir_file", XS_Apache_chdir_file, file);
        newXS("Apache::gensym", XS_Apache_gensym, file);
        newXS("Apache::slurp_filename", XS_Apache_slurp_filename, file);
        newXS("Apache::unescape_url", XS_Apache_unescape_url, file);
        newXS("Apache::unescape_url_info", XS_Apache_unescape_url_info, file);
        newXS("Apache::hard_timeout", XS_Apache_hard_timeout, file);
        newXS("Apache::soft_timeout", XS_Apache_soft_timeout, file);
        newXS("Apache::kill_timeout", XS_Apache_kill_timeout, file);
        newXS("Apache::reset_timeout", XS_Apache_reset_timeout, file);
        newXS("Apache::translate_name", XS_Apache_translate_name, file);
        newXS("Apache::custom_response", XS_Apache_custom_response, file);
        newXS("Apache::satisfies", XS_Apache_satisfies, file);
        newXS("Apache::some_auth_required", XS_Apache_some_auth_required, file);
        newXS("Apache::requires", XS_Apache_requires, file);
        newXS("Apache::allow_options", XS_Apache_allow_options, file);
        newXS("Apache::get_server_port", XS_Apache_get_server_port, file);
        newXS("Apache::get_server_name", XS_Apache_get_server_name, file);
        newXS("Apache::get_remote_host", XS_Apache_get_remote_host, file);
        newXS("Apache::get_remote_logname", XS_Apache_get_remote_logname, file);
        newXS("Apache::auth_name", XS_Apache_auth_name, file);
        newXS("Apache::auth_type", XS_Apache_auth_type, file);
        newXS("Apache::document_root", XS_Apache_document_root, file);
        newXS("Apache::server_root_relative", XS_Apache_server_root_relative, file);
        newXS("Apache::note_basic_auth_failure", XS_Apache_note_basic_auth_failure, file);
        newXS("Apache::get_basic_auth_pw", XS_Apache_get_basic_auth_pw, file);
        newXS("Apache::basic_http_header", XS_Apache_basic_http_header, file);
        newXS("Apache::send_http_header", XS_Apache_send_http_header, file);
        newXS("Apache::send_fd", XS_Apache_send_fd, file);
        newXS("Apache::rflush", XS_Apache_rflush, file);
        newXS("Apache::read_client_block", XS_Apache_read_client_block, file);
        newXS("Apache::setup_client_block", XS_Apache_setup_client_block, file);
        newXS("Apache::should_client_block", XS_Apache_should_client_block, file);
        newXS("Apache::get_client_block", XS_Apache_get_client_block, file);
        cv = newXS("Apache::print", XS_Apache_print, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::PRINT", XS_Apache_print, file);
        XSANY.any_i32 = 1 ;
        newXS("Apache::write_client", XS_Apache_write_client, file);
        cv = newXS("Apache::internal_redirect_handler", XS_Apache_internal_redirect_handler, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::internal_redirect", XS_Apache_internal_redirect_handler, file);
        XSANY.any_i32 = 1 ;
        newXS("Apache::log_reason", XS_Apache_log_reason, file);
        cv = newXS("Apache::log_error", XS_Apache_log_error, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::Server::warn", XS_Apache_log_error, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("Apache::Server::log_error", XS_Apache_log_error, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Apache::warn", XS_Apache_log_error, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::cgi_var", XS_Apache_subprocess_env, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Apache::cgi_env", XS_Apache_subprocess_env, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::subprocess_env", XS_Apache_subprocess_env, file);
        XSANY.any_i32 = 0 ;
        newXS("Apache::request", XS_Apache_request, file);
        newXS("Apache::connection", XS_Apache_connection, file);
        newXS("Apache::server", XS_Apache_server, file);
        newXS("Apache::main", XS_Apache_main, file);
        newXS("Apache::prev", XS_Apache_prev, file);
        newXS("Apache::next", XS_Apache_next, file);
        newXS("Apache::last", XS_Apache_last, file);
        newXS("Apache::is_initial_req", XS_Apache_is_initial_req, file);
        newXS("Apache::is_main", XS_Apache_is_main, file);
        newXS("Apache::the_request", XS_Apache_the_request, file);
        newXS("Apache::proxyreq", XS_Apache_proxyreq, file);
        newXS("Apache::header_only", XS_Apache_header_only, file);
        newXS("Apache::protocol", XS_Apache_protocol, file);
        newXS("Apache::hostname", XS_Apache_hostname, file);
        newXS("Apache::status", XS_Apache_status, file);
        newXS("Apache::request_time", XS_Apache_request_time, file);
        newXS("Apache::status_line", XS_Apache_status_line, file);
        newXS("Apache::method", XS_Apache_method, file);
        newXS("Apache::method_number", XS_Apache_method_number, file);
        newXS("Apache::bytes_sent", XS_Apache_bytes_sent, file);
        newXS("Apache::read_length", XS_Apache_read_length, file);
        newXS("Apache::header_in", XS_Apache_header_in, file);
        newXS("Apache::headers_in", XS_Apache_headers_in, file);
        newXS("Apache::header_out", XS_Apache_header_out, file);
        newXS("Apache::cgi_header_out", XS_Apache_cgi_header_out, file);
        newXS("Apache::headers_out", XS_Apache_headers_out, file);
        newXS("Apache::err_header_out", XS_Apache_err_header_out, file);
        newXS("Apache::err_headers_out", XS_Apache_err_headers_out, file);
        newXS("Apache::notes", XS_Apache_notes, file);
        newXS("Apache::pnotes", XS_Apache_pnotes, file);
        newXS("Apache::content_type", XS_Apache_content_type, file);
        newXS("Apache::handler", XS_Apache_handler, file);
        newXS("Apache::content_encoding", XS_Apache_content_encoding, file);
        newXS("Apache::content_language", XS_Apache_content_language, file);
        newXS("Apache::content_languages", XS_Apache_content_languages, file);
        newXS("Apache::no_cache", XS_Apache_no_cache, file);
        newXS("Apache::finfo", XS_Apache_finfo, file);
        newXS("Apache::uri", XS_Apache_uri, file);
        newXS("Apache::filename", XS_Apache_filename, file);
        newXS("Apache::path_info", XS_Apache_path_info, file);
        newXS("Apache::query_string", XS_Apache_query_string, file);
        newXS("Apache::location", XS_Apache_location, file);
        newXS("Apache::dir_config", XS_Apache_dir_config, file);
        newXS("Apache::lookup_uri", XS_Apache_lookup_uri, file);
        newXS("Apache::lookup_file", XS_Apache_lookup_file, file);
        newXS("Apache::SubRequest::DESTROY", XS_Apache__SubRequest_DESTROY, file);
        newXS("Apache::SubRequest::run", XS_Apache__SubRequest_run, file);
    }

    /* Initialisation Section */

#line 360 "Apache.xs"
    items = items; /*avoid warning*/ 

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 1856 "Apache.xs"
    av_push(perl_get_av("Apache::SubRequest::ISA",TRUE), newSVpv("Apache",6));

#line 3143 "Apache.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

