/*
 * This file was generated automatically by xsubpp version 1.9507 from the 
 * contents of Table.xs. Do not edit this file, edit Table.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Table.xs"
#include "mod_perl.h"

typedef struct {
    SV *cv;
    table *only;
} TableDo;

#define table_pool(t) ((array_header *)(t))->pool

static int Apache_table_do(TableDo *td, const char *key, const char *val)
{
    int count=0, rv=1;
    dSP;

    if(td->only && !table_get(td->only, key))
       return 1;

    ENTER;SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSVpv((char *)key,0)));
    XPUSHs(sv_2mortal(newSVpv((char *)val,0)));
    PUTBACK;
    count = perl_call_sv(td->cv, G_SCALAR);
    SPAGAIN;
    if(count == 1)
	rv = POPi;
    PUTBACK;
    FREETMPS;LEAVE;
    return rv;
}

static void table_modify(TiedTable *self, const char *key, SV *sv, 
			 void (*tabfunc) (table *, const char *, const char *))
{
    dTHR;
    const char *val;

    if(!self->table) return;

    if(SvROK(sv) && (SvTYPE(SvRV(sv)) == SVt_PVAV)) {
	I32 i;
	AV *av = (AV*)SvRV(sv);
	for(i=0; i<=AvFILL(av); i++) {
	    val = (const char *)SvPV(*av_fetch(av, i, FALSE),na);
            (*tabfunc)(self->table, key, val);
	}
    }
    else {
        val = (const char *)SvPV(sv,na);
	(*tabfunc)(self->table, key, val);
    }

}

static Apache__Table ApacheTable_new(table *table)
{
    Apache__Table RETVAL = (Apache__Table)safemalloc(sizeof(TiedTable));
    RETVAL->table = table;
    RETVAL->ix = 0;
    RETVAL->elts = NULL;
    RETVAL->arr = NULL;
    return RETVAL;
}

#line 75 "Table.c"
XS(XS_Apache__Table_TIEHASH)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::Table::TIEHASH(class, table)");
    {
	SV *	class = ST(0);
	Apache__table	table;
	Apache__Table	RETVAL;

	if (sv_derived_from(ST(1), "Apache::table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    table = (Apache__table) tmp;
	}
	else
	    croak("table is not of type Apache::table");
#line 78 "Table.xs"
    if(!class) XSRETURN_UNDEF;
    RETVAL = ApacheTable_new(table);

#line 96 "Table.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Table", (void*)RETVAL);

    }
    XSRETURN(1);
}

XS(XS_Apache__Table_new)
{
    dXSARGS;
    if (items < 2 || items > 3)
	croak("Usage: Apache::Table::new(class, r, nalloc=10)");
    {
	SV *	class = ST(0);
	Apache	r;
	int	nalloc;

	r = sv2request_rec(ST(1), "Apache", cv);

	if (items < 3)
	    nalloc = 10;
	else {
	    nalloc = (int)SvIV(ST(2));
	}
#line 91 "Table.xs"
    if(!class) XSRETURN_UNDEF;
    ST(0) = mod_perl_tie_table(make_table(r->pool, nalloc));
#line 124 "Table.c"
    }
    XSRETURN(1);
}

XS(XS_Apache__Table_DESTROY)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::Table::DESTROY(self)");
    {
	SV *	self = ST(0);
#line 99 "Table.xs"
    Apache__Table tab;

#line 139 "Table.c"
#line 102 "Table.xs"
    tab = (Apache__Table)hvrv2table(self);
    if(SvROK(self) && SvTYPE(SvRV(self)) == SVt_PVHV) 
        safefree(tab);
#line 144 "Table.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__Table_FETCH)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       croak("Usage: %s(self, key)", GvNAME(CvGV(cv)));
    SP -= items;
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
#line 115 "Table.xs"
    ix = ix; /*avoid warning*/
    if(!self->table) XSRETURN_UNDEF;
    if(GIMME == G_SCALAR) {
	const char *val = table_get(self->table, key);
	if (val) XPUSHs(sv_2mortal(newSVpv((char*)val,0)));
	else XSRETURN_UNDEF;
    }
    else {
	int i;
	array_header *arr  = table_elts(self->table);
	table_entry *elts = (table_entry *)arr->elts;
	for (i = 0; i < arr->nelts; ++i) {
	    if (!elts[i].key || strcasecmp(elts[i].key, key)) continue;
	    XPUSHs(sv_2mortal(newSVpv(elts[i].val,0)));
	}
    }
#line 176 "Table.c"
	PUTBACK;
	return;
    }
}

XS(XS_Apache__Table_EXISTS)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Apache::Table::EXISTS(self, key)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
	bool	RETVAL;
#line 138 "Table.xs"
    if(!self->table) XSRETURN_UNDEF;
    RETVAL = table_get(self->table, key) ? TRUE : FALSE;

#line 195 "Table.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Apache__Table_DELETE)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       croak("Usage: %s(self, key)", GvNAME(CvGV(cv)));
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
#line 153 "Table.xs"
    I32 gimme = GIMME_V;

#line 214 "Table.c"
	const char *	RETVAL;
#line 156 "Table.xs"
    ix = ix;
    if(!self->table) XSRETURN_UNDEF;
    RETVAL = NULL;
    if(gimme != G_VOID)
        RETVAL = table_get(self->table, key);
    table_unset(self->table, key);
    if(!RETVAL) XSRETURN_UNDEF;

#line 225 "Table.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache__Table_STORE)
{
    dXSARGS;
    dXSI32;
    if (items != 3)
       croak("Usage: %s(self, key, val)", GvNAME(CvGV(cv)));
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
	const char *	val = (const char *)SvPV(ST(2),PL_na);
#line 177 "Table.xs"
    ix = ix; /*avoid warning*/
    if(!self->table) XSRETURN_UNDEF;
    table_set(self->table, key, val);
#line 246 "Table.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__Table_CLEAR)
{
    dXSARGS;
    dXSI32;
    if (items != 1)
       croak("Usage: %s(self)", GvNAME(CvGV(cv)));
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
#line 189 "Table.xs"
    ix = ix; /*avoid warning*/
    if(!self->table) XSRETURN_UNDEF;
    clear_table(self->table);
#line 263 "Table.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__Table_NEXTKEY)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Apache::Table::NEXTKEY(self, lastkey=Nullsv)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	SV *	lastkey;
	const char *	RETVAL;

	if (items < 2)
	    lastkey = Nullsv;
	else {
	    lastkey = ST(1);
	}
#line 199 "Table.xs"
    if(self->ix >= self->arr->nelts) XSRETURN_UNDEF;
    RETVAL = self->elts[self->ix++].key;

#line 287 "Table.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache__Table_FIRSTKEY)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Apache::Table::FIRSTKEY(self)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	RETVAL;
#line 210 "Table.xs"
    if(!self->table) XSRETURN_UNDEF;
    self->arr = table_elts(self->table);
    if(!self->arr->nelts) XSRETURN_UNDEF;
    self->elts = (table_entry *)self->arr->elts;
    self->ix = 0;
    RETVAL = self->elts[self->ix++].key;

#line 310 "Table.c"
	ST(0) = sv_newmortal();
	sv_setpv((SV*)ST(0), RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Apache__Table_add)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::Table::add(self, key, sv)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
	SV *	sv = ST(2);
#line 227 "Table.xs"
    table_modify(self, key, sv, (void*)table_add);
#line 328 "Table.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__Table_merge)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Apache::Table::merge(self, key, sv)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	const char *	key = (const char *)SvPV(ST(1),PL_na);
	SV *	sv = ST(2);
#line 236 "Table.xs"
    table_modify(self, key, sv, (void*)table_merge);
#line 344 "Table.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Apache__Table_do)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Apache::Table::do(self, cv, ...)");
    {
	Apache__Table	self = (Apache__Table)hvrv2table(ST(0));
	SV *	cv = ST(1);
#line 244 "Table.xs"
    TableDo td;
    td.only = (table *)NULL;

#line 361 "Table.c"
#line 248 "Table.xs"
    if(items > 2) {
	int i;
	STRLEN len;
        td.only = make_table(table_pool(self->table), items-2);
	for(i=2; ; i++) {
	    char *key = SvPV(ST(i),len);
	    table_set(td.only, key, "1");
	    if(i == (items - 1)) break; 
	}
    }
    td.cv = cv;

    table_do((int (*) (void *, const char *, const char *)) Apache_table_do,
	    (void *) &td, self->table, NULL);
#line 377 "Table.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Apache__Table)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Apache::Table::TIEHASH", XS_Apache__Table_TIEHASH, file);
        newXS("Apache::Table::new", XS_Apache__Table_new, file);
        newXS("Apache::Table::DESTROY", XS_Apache__Table_DESTROY, file);
        cv = newXS("Apache::Table::get", XS_Apache__Table_FETCH, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::Table::FETCH", XS_Apache__Table_FETCH, file);
        XSANY.any_i32 = 0 ;
        newXS("Apache::Table::EXISTS", XS_Apache__Table_EXISTS, file);
        cv = newXS("Apache::Table::unset", XS_Apache__Table_DELETE, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::Table::DELETE", XS_Apache__Table_DELETE, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::Table::set", XS_Apache__Table_STORE, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::Table::STORE", XS_Apache__Table_STORE, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::Table::CLEAR", XS_Apache__Table_CLEAR, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Apache::Table::clear", XS_Apache__Table_CLEAR, file);
        XSANY.any_i32 = 1 ;
        newXS("Apache::Table::NEXTKEY", XS_Apache__Table_NEXTKEY, file);
        newXS("Apache::Table::FIRSTKEY", XS_Apache__Table_FIRSTKEY, file);
        newXS("Apache::Table::add", XS_Apache__Table_add, file);
        newXS("Apache::Table::merge", XS_Apache__Table_merge, file);
        newXS("Apache::Table::do", XS_Apache__Table_do, file);
    }

    /* Initialisation Section */

#line 70 "Table.xs"
    items = items; /*avoid warning*/ 

#line 427 "Table.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

